## qmmp 1.1.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11 FATAL_ERROR)

#freebsd support
include_directories(SYSTEM /usr/local/include)
SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)

#macports support
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
ENDIF()

#Qt5 modules
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /opt/qt56/lib/cmake)

#extract version from qmmp.h
FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/qmmp/qmmp.h"
     QMMP_VERSION_DATA REGEX "^#define[ \t]+QMMP_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

IF(QMMP_VERSION_DATA)
   FOREACH(item IN ITEMS MAJOR MINOR PATCH STABLE)
      STRING(REGEX REPLACE ".*#define[ \t]+QMMP_VERSION_${item}[ \t]+([0-9]+).*"
       "\\1" QMMP_VERSION_${item} ${QMMP_VERSION_DATA})
   ENDFOREACH(item IN ITEMS MAJOR MINOR PATCH)
   SET(QMMP_VERSION "${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}.${QMMP_VERSION_PATCH}")
   SET(QMMP_SOVERSION "${QMMP_VERSION_MAJOR}")
   IF(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (stable)")
   ELSE(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (development)")
   ENDIF(QMMP_VERSION_STABLE)
ELSE(QMMP_VERSION_DATA)
   MESSAGE(FATAL_ERROR "invalid header")
ENDIF(QMMP_VERSION_DATA)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

INCLUDE(FindPkgConfig)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt5Widgets 5.4.0 REQUIRED)
find_package(Qt5LinguistTools 5.4.0 REQUIRED)
find_package(Qt5Network 5.4.0 REQUIRED)
find_package(Qt5X11Extras 5.4.0)
find_package(Qt5DBus 5.4.0)
find_package(Qt5Multimedia 5.4.0)
ADD_DEFINITIONS(-DQMMP_WS_X11)

get_target_property(QT_LRELEASE_EXECUTABLE Qt5::lrelease IMPORTED_LOCATION)

IF(QT_LRELEASE_EXECUTABLE)
MESSAGE(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
ELSE(QT_LRELEASE_EXECUTABLE)
MESSAGE(FATAL_ERROR "Could NOT find lrelease executable")
ENDIF(QT_LRELEASE_EXECUTABLE)

MESSAGE(STATUS "Generating translations ...")
IF(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent -nounfinished)
ELSE(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
ENDIF(SVN_VERSION)

get_target_property(QT_LIBRARY_DIR Qt5::Core LOCATION)
get_filename_component(QT_LIBRARY_DIR ${QT_LIBRARY_DIR} PATH)

IF(NOT LIB_SUFFIX)
IF("${QT_LIBRARY_DIR}" MATCHES lib64)
set(LIB_SUFFIX 64)
ENDIF("${QT_LIBRARY_DIR}" MATCHES lib64)
ENDIF(NOT LIB_SUFFIX)

SET(LIB_DIR "lib${LIB_SUFFIX}" CACHE STRING "library path")
SET(USE_SKINNED TRUE CACHE BOOL "enable/disable standard skinned user interface")
SET(USE_DIR_ASSOC TRUE CACHE BOOL "enable/disable inode/directory mime type association")

pkg_search_module(X11 x11)

add_subdirectory(src/qmmp)
add_subdirectory(src/qmmpui)
add_subdirectory(src/plugins)
add_subdirectory(src/app)

MACRO(PRINT_SUMMARY str USE FOUND)
IF(${USE} AND ${FOUND})
MESSAGE("${str}enabled")
ELSE(${USE} AND ${FOUND})
MESSAGE("${str}disabled")
ENDIF(${USE} AND ${FOUND})
ENDMACRO(PRINT_SUMMARY)

IF (UNIX)
ADD_CUSTOM_TARGET (distclean @echo cleaning for source distribution)

ADD_CUSTOM_COMMAND(
    COMMENT "distribution clean"
    COMMAND make
    ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
    TARGET  distclean
)
ENDIF(UNIX)


MESSAGE("")
MESSAGE("Transports:")
PRINT_SUMMARY ("HTTP support ......................" USE_CURL CURL_FOUND)
PRINT_SUMMARY ("MMS support ......................." USE_MMS MMS_FOUND)

MESSAGE("")
MESSAGE("Input Plugins:")
PRINT_SUMMARY ("mp3 support ......................." USE_MAD  MAD_FOUND)
PRINT_SUMMARY ("FLAC support ......................" USE_FLAC FLAC_FOUND)
PRINT_SUMMARY ("Ogg Vorbis support ................" USE_VORBIS VORBIS_FOUND)
PRINT_SUMMARY ("Musepack support .................." USE_MPC MPC_FOUND)
PRINT_SUMMARY ("MOD support ......................." USE_MODPLUG MODPLUG_FOUND)
PRINT_SUMMARY ("Wave support ......................" USE_SNDFILE SNDFILE_FOUND)
PRINT_SUMMARY ("WavPack support ..................." USE_WAVPACK WAVPACK_FOUND)
PRINT_SUMMARY ("FFmpeg/Libav support .............." USE_FFMPEG FFMPEG_FOUND)
PRINT_SUMMARY ("AAC support ......................." USE_AAC FAAD_FOUND)
PRINT_SUMMARY ("CUE sheet support ................." USE_CUE 1)
PRINT_SUMMARY ("Mplayer support ..................." USE_MPLAYER 1)
PRINT_SUMMARY ("CD Audio support .................." USE_CDA CDIO_FOUND)
PRINT_SUMMARY ("Midi support ......................" USE_MIDI WILDMIDI_FOUND)
PRINT_SUMMARY ("Game music support ................" USE_GME GME_FOUND)
PRINT_SUMMARY ("Ogg Opus support .................." USE_OPUS OPUS_FOUND)
PRINT_SUMMARY ("SID support ......................." USE_SID SIDPLAYFP_FOUND)

MESSAGE("")
MESSAGE("Output Plugins:")
PRINT_SUMMARY ("ALSA support ......................" USE_ALSA ALSA_FOUND)
PRINT_SUMMARY ("OSS support ......................." USE_OSS 1)
PRINT_SUMMARY ("OSS4 support ......................" USE_OSS4 OSS4_FOUND)
PRINT_SUMMARY ("JACK support ......................" USE_JACK JACK_FOUND)
PRINT_SUMMARY ("PulseAudio support ................" USE_PULSE PULSE_FOUND)
PRINT_SUMMARY ("Null output support ..............." USE_NULL 1)
PRINT_SUMMARY ("Win32 Waveout support ............." USE_WAVEOUT WINDOWS_H_FOUND)
PRINT_SUMMARY ("Win32 DirectSound support ........." USE_DSOUND DSOUND_H_FOUND)
PRINT_SUMMARY ("Win32 WASAPI support .............." USE_WASAPI WASAPI_FOUND)
PRINT_SUMMARY ("Qt Multimedia support ............." USE_QTMULTIMEDIA Qt5Multimedia_FOUND)

MESSAGE("")
MESSAGE("Effect Plugins:")
PRINT_SUMMARY ("SoX Resampler ....................." USE_SOXR SOXR_FOUND)
PRINT_SUMMARY ("BS2B Plugin ......................." USE_BS2B BS2B_FOUND)
PRINT_SUMMARY ("LADSPA Host ......................." USE_LADSPA 1)
PRINT_SUMMARY ("Crossfade ........................." USE_CROSSFADE 1)
PRINT_SUMMARY ("Extra Stereo ......................" USE_STEREO 1)

MESSAGE("")
MESSAGE("Visual Plugins:")
PRINT_SUMMARY ("Analyzer .........................." USE_ANALYZER 1)
PRINT_SUMMARY ("ProjectM .........................." USE_PROJECTM PROJECTM_FOUND)

MESSAGE("")
MESSAGE("General Plugins:")
PRINT_SUMMARY ("MPRIS support ....................." USE_MPRIS Qt5DBus_FOUND)
PRINT_SUMMARY ("Scrobbler ........................." USE_SCROBBLER 1)
PRINT_SUMMARY ("Tray support ......................" USE_STATICON 1)
PRINT_SUMMARY ("Notifier support .................." USE_NOTIFIER 1)
PRINT_SUMMARY ("Lyrics support ...................." USE_LYRICS 1)
PRINT_SUMMARY ("HAL support ......................." USE_HAL Qt5DBus_FOUND)
PRINT_SUMMARY ("UDisks2 support ..................." USE_UDISKS2 Qt5DBus_FOUND)
PRINT_SUMMARY ("Global hotkey support ............." USE_HOTKEY X11_FOUND)
PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ....." USE_GNOMEHOTKEY Qt5DBus_FOUND)
PRINT_SUMMARY ("File operations ..................." USE_FILEOPS 1)
PRINT_SUMMARY ("Cover manager ....................." USE_COVER 1)
PRINT_SUMMARY ("KDE4 notifications support ........" USE_KDENOTIFY Qt5DBus_FOUND)
PRINT_SUMMARY ("Audio converter ..................." USE_CONVERTER TAGLIB_FOUND)
PRINT_SUMMARY ("ReplayGain Scanner ................" USE_RGSCAN TAGLIB_FOUND)
PRINT_SUMMARY ("Stream browser ...................." USE_SB 1)
PRINT_SUMMARY ("Track change ......................" USE_TRACKCHANGE 1)
PRINT_SUMMARY ("Copy/Paste ........................" USE_COPYPASTE 1)

MESSAGE("")
MESSAGE("File Dialogs:")
PRINT_SUMMARY ("QMMP File Dialog .................." USE_QMMP_DIALOG 1)
PRINT_SUMMARY ("Two-panel File File Dialog ........" USE_TWO_PANEL_DIALOG 1)

MESSAGE("")
MESSAGE("Advanced:")
PRINT_SUMMARY ("Skinned user interface ............" USE_SKINNED X11_FOUND)
PRINT_SUMMARY ("Simple user interface (QSUI) ......" USE_QSUI 1)
PRINT_SUMMARY ("Automatic charset detection ......." USE_ENCA ENCA_FOUND)
PRINT_SUMMARY ("Directory association ............." USE_DIR_ASSOC 1)
PRINT_SUMMARY ("Set RPATH in installed binaries ..." CMAKE_INSTALL_RPATH_USE_LINK_PATH 1)

MESSAGE("")

=== debian/changelog ===
qmmp (1.1.6-1.1ubuntu1) artful; urgency=medium

  * Disable qmmp-plugin-projectm on arm64, where Qt is also linked to GLESv2
    in Ubuntu.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 31 Aug 2017 00:26:01 -0700

qmmp (1.1.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop build-dependency on oss4-dev on Linux kernel (Closes: #852986)
    - d/rules: explicitly disable OSS4 on Linux, for predictability

 -- Simon McVittie <smcv@debian.org>  Sun, 29 Jan 2017 12:00:10 +0000

qmmp (1.1.6-1) unstable; urgency=medium

  * New upstream release.
  * Suggest mplayer instead of mplayer2. (Closes: #841193)
  * Switch to debhelper compat 10.

 -- Matteo Cypriani <mcy@lm7.fr>  Mon, 16 Jan 2017 14:03:58 -0500

qmmp (1.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches (included upstream, not needed any more).
  * Update Build-Depends.
  * Update package description.

 -- Matteo Cypriani <mcy@lm7.fr>  Fri, 07 Oct 2016 09:00:36 -0400

qmmp (1.0.9-1) unstable; urgency=medium

  * Acknowledging NMU.
  * New upstream version 1.0.9.
  * Update debian/copyright.
  * Bump Standards-Version to 3.9.8.
  * Use DEB_BUILD_MAINT_OPTIONS to set hardening flags.
  * Use secure URIs for Vcs-Git and Vcs-Browser.
  * New patch: Fix conversion in wildmidi plugin (Closes: #835079).
  * New patch: Fix typo in "Highlighted".

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 18 Sep 2016 10:54:59 -0400

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matteo Cypriani <mcy@lm7.fr>
Build-Depends: debhelper (>= 10), cmake, pkg-config, qtbase5-dev (>= 5.4),
  libqt5x11extras5-dev (>= 5.4), qttools5-dev-tools (>= 5.4),
  qtchooser, libx11-dev, oss4-dev [!linux-any], libmad0-dev, libvorbis-dev,
  libogg-dev, libasound2-dev [linux-any], libtag1-dev (>= 1.10),
  libcurl4-gnutls-dev, qtmultimedia5-dev (>= 5.4), libmms-dev,
  libflac-dev, libmpcdec-dev, libjack-jackd2-dev, libsoxr-dev,
  libmodplug-dev, libsndfile1-dev, libwavpack-dev, libpulse-dev,
  libavcodec-dev, libavformat-dev, libcdio-dev, libcdio-paranoia-dev,
  libcddb2-dev, libfaad-dev, libgme-dev, libopus-dev (>= 1.0.2),
  libopusfile-dev, libwildmidi-dev, libsidplayfp-dev (>= 1.0.3),
  libbs2b-dev, libprojectm-dev [!armel !armhf !arm64], libenca-dev
Standards-Version: 3.9.8
Homepage: http://qmmp.ylsoftware.com/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/qmmp.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/qmmp.git

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qmmp-plugin-projectm, mplayer, unzip, udisks2 [linux-any],
  hal [!linux-any]
Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Description: feature-rich audio player with support of many formats
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Audio output through:
  - ALSA
  - OSS
  - PulseAudio
  - JACK
  - QTMultimedia
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - mms support
  - MPRIS (1.0 and 2.0)
  - removable device detection (via HAL or UDisks)
  - video playback via Mplayer
  - lyrics (using lyrics.wikia.com)
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC and WavPack)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - Last.fm/Libre.fm scrobbler
  - CDDB support
  - audio converter
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - visualization (spectre analyzer, projectm)
  - global hotkeys

Package: qmmp-plugin-projectm
Architecture: any-amd64 any-i386 any-mips any-mipsel any-powerpc any-ppc64el any-s390x any-alpha any-hppa any-m68k any-mips64el any-powerpcspe any-sh4 any-sparc64 any-x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains projectM visualization plugin for qmmp.

## qmmp 1.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -121,8 +121,12 @@
     ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
     COMMAND find
     ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
+    COMMAND find
+    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
     COMMAND rm
     ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
+    COMMAND find
+    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
     TARGET  distclean
 )
 ENDIF(UNIX)
@@ -187,7 +191,7 @@
 PRINT_SUMMARY ("Lyrics support ...................." USE_LYRICS 1)
 PRINT_SUMMARY ("HAL support ......................." USE_HAL Qt5DBus_FOUND)
 PRINT_SUMMARY ("UDisks2 support ..................." USE_UDISKS2 Qt5DBus_FOUND)
-PRINT_SUMMARY ("Global hotkey support ............." USE_HOTKEY X11_FOUND)
+PRINT_SUMMARY ("Global hotkey support ............." USE_HOTKEY X11_FOUND AND Qt5X11Extras_FOUND)
 PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ....." USE_GNOMEHOTKEY Qt5DBus_FOUND)
 PRINT_SUMMARY ("File operations ..................." USE_FILEOPS 1)
 PRINT_SUMMARY ("Cover manager ....................." USE_COVER 1)
@@ -205,7 +209,7 @@
 
 MESSAGE("")
 MESSAGE("Advanced:")
-PRINT_SUMMARY ("Skinned user interface ............" USE_SKINNED X11_FOUND)
+PRINT_SUMMARY ("Skinned user interface ............" USE_SKINNED X11_FOUND AND Qt5X11Extras_FOUND)
 PRINT_SUMMARY ("Simple user interface (QSUI) ......" USE_QSUI 1)
 PRINT_SUMMARY ("Automatic charset detection ......." USE_ENCA ENCA_FOUND)
 PRINT_SUMMARY ("Directory association ............." USE_DIR_ASSOC 1)

=== src/app/CMakeLists.txt ===
project(app)

if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
   cmake_policy(SET CMP0005 OLD)
endif(COMMAND cmake_policy) 

INCLUDE(UsePkgConfig)

ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_THREAD)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


# libqmmp & libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

link_directories(${CMAKE_INSTALL_PREFIX}/${LIB_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmp)

SET(app_SRCS
    builtincommandlineoption.cpp
    main.cpp
    qmmpstarter.cpp
)

SET(app_RCCS images/images.qrc translations/qmmp_locales.qrc)

QT5_ADD_RESOURCES(app_RCC_SRCS ${app_RCCS})

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_EXECUTABLE(qmmp ${app_SRCS} ${app_RCC_SRCS})
target_link_libraries(qmmp Qt5::Widgets libqmmp qmmpui)
add_dependencies(qmmp qmmpui libqmmp)
install(TARGETS qmmp DESTINATION bin)
install(FILES qmmp.desktop DESTINATION share/applications)
install(FILES images/16x16/qmmp.png DESTINATION share/icons/hicolor/16x16/apps)
install(FILES images/32x32/qmmp.png DESTINATION share/icons/hicolor/32x32/apps)
install(FILES images/48x48/qmmp.png DESTINATION share/icons/hicolor/48x48/apps)
install(FILES images/scalable/qmmp.svgz images/scalable/qmmp-simple.svgz DESTINATION share/icons/hicolor/scalable/apps)

IF(USE_DIR_ASSOC)
install(FILES qmmp_enqueue.desktop DESTINATION share/applications)
install(FILES qmmp_dir.desktop DESTINATION share/applications)
ENDIF(USE_DIR_ASSOC)

=== src/qmmp/CMakeLists.txt ===
project(libqmmp)

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 OLD)
    cmake_policy(SET CMP0005 OLD)
endif(COMMAND cmake_policy)

ADD_DEFINITIONS(-DLIB_DIR=\\\"/${LIB_DIR}\\\")
ADD_DEFINITIONS(-DQMMP_INSTALL_PREFIX=\\\"${CMAKE_INSTALL_PREFIX}\\\")

IF(NOT QMMP_VERSION_STABLE) #add svn revision
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/svn_revision.sh
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                OUTPUT_VARIABLE SVN_REVISION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
IF(SVN_REVISION)
ADD_DEFINITIONS(-DSVN_REVISION=\\\"${SVN_REVISION}\\\")
ENDIF(SVN_REVISION)
ENDIF(NOT QMMP_VERSION_STABLE)

include_directories(${CMAKE_CURRENT_BINARY_DIR})


SET(QMMP_DEFAULT_OUTPUT "" CACHE STRING "default output plugin")
IF(QMMP_DEFAULT_OUTPUT)
    ADD_DEFINITIONS(-DQMMP_DEFAULT_OUTPUT=\\\"${QMMP_DEFAULT_OUTPUT}\\\")
    MESSAGE(STATUS "Default output: ${QMMP_DEFAULT_OUTPUT}")
ENDIF(QMMP_DEFAULT_OUTPUT)


SET(libqmmp_SRCS
    visual.cpp
    recycler.cpp
    decoder.cpp
    output.cpp
    outputwriter.cpp
    fileinfo.cpp
    equ/iir.c
    equ/iir_cfs.c
    equ/iir_fpu.c
    soundcore.cpp
    effect.cpp
    qmmp.cpp
    statehandler.cpp
    volumecontrol.cpp
    metadatamodel.cpp
    tagmodel.cpp
    qmmpaudioengine.cpp
    abstractengine.cpp
    audioparameters.cpp
    inputsource.cpp
    fileinputsource.cpp
    emptyinputsource.cpp
    metadatamanager.cpp
    replaygain.cpp
    qmmpsettings.cpp
    audioconverter.cpp
    eqsettings.cpp
    qmmpevents.cpp
    qmmpplugincache.cpp
    channelmap.cpp
    channelconverter.cpp
    volume.cpp
    dithering.cpp
)

SET(libqmmp_HDRS
    qmmpevents_p.h
    outputfactory.h
    decoderfactory.h
    effectfactory.h
    equ/iir_cfs.h
    equ/iir_fpu.h
    equ/iir.h
    visualfactory.h
    recycler_p.h
    buffer.h
    effect.h
    qmmp.h
    replaygain_p.h
    fileinfo.h
    audioconverter.h
    qmmpplugincache_p.h
    eqsettings.h
    decoder.h
    tagmodel.h
    audioparameters.h
    inputsourcefactory.h
    enginefactory.h
    metadatamanager.h
    output.h
    channelmap.h
    channelconverter_p.h
    dithering_p.h
)

SET(libqmmp_DEVEL_HDRS
    abstractengine.h
    audioconverter.h
    audioparameters.h
    buffer.h
    channelmap.h
    decoderfactory.h
    decoder.h
    effectfactory.h
    effect.h
    enginefactory.h
    eqsettings.h
    fileinfo.h
    inputsourcefactory.h
    inputsource.h
    metadatamanager.h
    metadatamodel.h
    outputfactory.h
    output.h
    qmmp.h
    qmmpsettings.h
    soundcore.h
    statehandler.h
    tagmodel.h
    visualfactory.h
    visual.h
    volume.h
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(libqmmp SHARED ${libqmmp_SRCS} ${libqmmp_HDRS})
target_link_libraries(libqmmp Qt5::Widgets)
SET_TARGET_PROPERTIES(libqmmp PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmp)
install(TARGETS libqmmp LIBRARY DESTINATION ${LIB_DIR}
                        RUNTIME DESTINATION bin
                        ARCHIVE DESTINATION ${LIB_DIR})
install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION include/qmmp)


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmp.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmp.pc DESTINATION ${LIB_DIR}/pkgconfig)

=== src/plugins/Effect/CMakeLists.txt ===
SET(USE_SOXR TRUE CACHE BOOL "enable/disable SoX resampler plugin")
SET(USE_BS2B TRUE CACHE BOOL "enable/disable bs2b plugin")
SET(USE_LADSPA TRUE CACHE BOOL "enable/disable ladspa plugin")
SET(USE_CROSSFADE TRUE CACHE BOOL "enable/disable crossfade plugin")
SET(USE_STEREO TRUE CACHE BOOL "enable/disable extra stereo plugin")

IF(USE_SOXR)
add_subdirectory(soxr)
ENDIF(USE_SOXR)

IF(USE_BS2B)
add_subdirectory(bs2b)
ENDIF(USE_BS2B)

IF(USE_LADSPA)
add_subdirectory(ladspa)
ENDIF(USE_LADSPA)

IF(USE_CROSSFADE)
add_subdirectory(crossfade)
ENDIF(USE_CROSSFADE)

IF(USE_STEREO)
add_subdirectory(stereo)
ENDIF(USE_STEREO)

=== src/plugins/General/CMakeLists.txt ===
SET(USE_MPRIS TRUE CACHE BOOL "enable/disable mpris plugin")
SET(USE_SCROBBLER TRUE CACHE BOOL "enable/disable scrobbler plugin")
SET(USE_STATICON TRUE CACHE BOOL "enable/disable status icon plugin")
SET(USE_NOTIFIER TRUE CACHE BOOL "enable/disable notifier plugin")
SET(USE_LYRICS TRUE CACHE BOOL "enable/disable lyrics version")
SET(USE_HAL (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD") CACHE BOOL "enable/disable hal plugin")
SET(USE_UDISKS2 TRUE CACHE BOOL "enable/disable udisks2 plugin")
SET(USE_HOTKEY TRUE CACHE BOOL "enable/disable global hotkey plugin")
SET(USE_GNOMEHOTKEY TRUE CACHE BOOL "enable/disable gnome hotkey plugin")
SET(USE_FILEOPS TRUE CACHE BOOL "enable/disable fileops plugin")
SET(USE_COVER TRUE CACHE BOOL "enable/disable cover manager plugin")
SET(USE_KDENOTIFY TRUE CACHE BOOL "enable/disable kde notification plugin")
SET(USE_CONVERTER TRUE CACHE BOOL "enable/disable audio converter plugin")
SET(USE_RGSCAN TRUE CACHE BOOL "enable/disable replaygain scanner plugin")
SET(USE_SB TRUE CACHE BOOL "enable/disable stream browser plugin")
SET(USE_TRACKCHANGE TRUE CACHE BOOL "enable/disable track change plugin")
SET(USE_COPYPASTE TRUE CACHE BOOL "enable/disable copy/paste change plugin")

IF(USE_MPRIS AND Qt5DBus_FOUND)
add_subdirectory(mpris)
ENDIF(USE_MPRIS AND Qt5DBus_FOUND)

IF(USE_SCROBBLER)
add_subdirectory(scrobbler)
ENDIF(USE_SCROBBLER)

IF(USE_STATICON)
add_subdirectory(statusicon)
ENDIF(USE_STATICON)

IF(USE_NOTIFIER)
add_subdirectory(notifier)
ENDIF(USE_NOTIFIER)

IF(USE_LYRICS)
add_subdirectory(lyrics)
ENDIF(USE_LYRICS)

IF(USE_HAL AND Qt5DBus_FOUND)
add_subdirectory(hal)
ENDIF(USE_HAL AND Qt5DBus_FOUND)

IF(USE_UDISKS2 AND Qt5DBus_FOUND)
add_subdirectory(udisks2)
ENDIF(USE_UDISKS2 AND Qt5DBus_FOUND)

IF(USE_HOTKEY AND Qt5X11Extras_FOUND)
add_subdirectory(hotkey)
ENDIF(USE_HOTKEY AND Qt5X11Extras_FOUND)

IF(USE_FILEOPS)
add_subdirectory(fileops)
ENDIF(USE_FILEOPS)

IF(USE_COVER)
add_subdirectory(covermanager)
ENDIF(USE_COVER)

IF(USE_KDENOTIFY AND Qt5DBus_FOUND)
add_subdirectory(kdenotify)
ENDIF(USE_KDENOTIFY AND Qt5DBus_FOUND)

IF(USE_CONVERTER AND TAGLIB_FOUND)
add_subdirectory(converter)
ENDIF(USE_CONVERTER AND TAGLIB_FOUND)

IF(USE_RGSCAN AND TAGLIB_FOUND)
add_subdirectory(rgscan)
ENDIF(USE_RGSCAN AND TAGLIB_FOUND)

IF(USE_SB)
add_subdirectory(streambrowser)
ENDIF(USE_SB)

IF(USE_TRACKCHANGE)
add_subdirectory(trackchange)
ENDIF(USE_TRACKCHANGE)

IF(USE_COPYPASTE)
add_subdirectory(copypaste)
ENDIF(USE_COPYPASTE)

IF(USE_GNOMEHOTKEY AND Qt5DBus_FOUND)
add_subdirectory(gnomehotkey)
ENDIF(USE_GNOMEHOTKEY AND Qt5DBus_FOUND)

=== src/plugins/CommandLineOptions/SeekOption/CMakeLists.txt ===
project(seekoption)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(seekoption_SRCS
    seekoption.cpp
)

SET(seekoption_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(seekoption_RCC_SRCS ${seekoption_RCCS})


# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(seekoption MODULE ${seekoption_SRCS} ${seekoption_RCC_SRCS})
add_dependencies(seekoption qmmpui)
target_link_libraries(seekoption Qt5::Widgets -lqmmpui -lqmmp)
install(TARGETS seekoption DESTINATION ${LIB_DIR}/qmmp/CommandLineOptions)

=== src/plugins/Effect/bs2b/CMakeLists.txt ===
project(libbs2b)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libbs2b_SRCS
    bs2bplugin.cpp
    settingsdialog.cpp
    effectbs2bfactory.cpp
)

SET(libbs2b_HDRS
    bs2bplugin.h
)

SET(libbs2b_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libbs2b_RCC_SRCS ${libbs2b_RCCS})

pkg_search_module(BS2B libbs2b>=3.0.0)

include_directories(${BS2B_INCLUDE_DIRS})
link_directories(${BS2B_LIBRARY_DIRS})
ADD_DEFINITIONS(${BS2B_CFLAGS})

# user interface

SET(libbs2b_UIS
    settingsdialog.ui
)

QT5_WRAP_UI(libbs2b_UIS_H ${libbs2b_UIS})
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

IF(BS2B_FOUND)
ADD_LIBRARY(bs2b MODULE ${libbs2b_SRCS} ${libbs2b_UIS_H}
  ${libbs2b_RCC_SRCS} ${libbs2b_HDRS})
add_dependencies(bs2b qmmp)
target_link_libraries(bs2b Qt5::Widgets -lqmmp ${BS2B_LDFLAGS})
install(TARGETS bs2b DESTINATION ${LIB_DIR}/qmmp/Effect)
ENDIF(BS2B_FOUND)

=== src/plugins/Effect/soxr/CMakeLists.txt ===
project(libsoxr)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# qt plugin
ADD_DEFINITIONS( -Wall )
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_NO_DEBUG)
ADD_DEFINITIONS(-DQT_SHARED)
ADD_DEFINITIONS(-DQT_THREAD)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

SET(QT_INCLUDES
  ${QT_INCLUDES}
  ${CMAKE_CURRENT_SOURCE_DIR}/../../../
)

# libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

pkg_check_modules(SOXR soxr)

include_directories(${SOXR_INCLUDE_DIRS})
link_directories(${SOXR_LIBRARY_DIRS})
ADD_DEFINITIONS(${SOXR_CFLAGS})

SET(libsoxr_SRCS
    soxresampler.cpp
    settingsdialog.cpp
    effectsoxrfactory.cpp
)

SET(libsoxr_HDRS
    soxresampler.h
)

SET(libsoxr_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libsoxr_RCC_SRCS ${libsoxr_RCCS})

# user interface

SET(libsoxr_UIS
    settingsdialog.ui
)

QT5_WRAP_UI(libsoxr_UIS_H ${libsoxr_UIS})
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

IF(SOXR_FOUND)
ADD_LIBRARY(soxr MODULE ${libsoxr_SRCS} ${libsoxr_UIS_H} ${libsoxr_RCC_SRCS} ${libsoxr_HDRS})
add_dependencies(soxr qmmp)
target_link_libraries(soxr Qt5::Widgets -lqmmp ${SOXR_LDFLAGS})
install(TARGETS soxr DESTINATION ${LIB_DIR}/qmmp/Effect)
ENDIF(SOXR_FOUND)

=== src/plugins/Effect/stereo/CMakeLists.txt ===
project(libstereo)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libstereo_SRCS
    stereoplugin.cpp
    settingsdialog.cpp
    effectstereofactory.cpp
)

SET(libstereo_HDRS
    stereoplugin.h
)

SET(libstereo_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libstereo_RCC_SRCS ${libstereo_RCCS})

# user interface

SET(libstereo_UIS
    settingsdialog.ui
)

QT5_WRAP_UI(libstereo_UIS_H ${libstereo_UIS})
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})


ADD_LIBRARY(stereo MODULE ${libstereo_SRCS} ${libstereo_UIS_H} ${libstereo_RCC_SRCS} ${libstereo_HDRS})
add_dependencies(stereo qmmp)
target_link_libraries(stereo Qt5::Widgets -lqmmp)
install(TARGETS stereo DESTINATION ${LIB_DIR}/qmmp/Effect)

=== src/plugins/FileDialogs/QmmpFileDialog/CMakeLists.txt ===
project(libqmmpfiledialog)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libqmmpfiledialog_SRCS
    qmmpfiledialogimpl.cpp
    qmmpfiledialog.cpp
)

SET(libqmmpfiledialog_RCCS
    translations/translations.qrc)

QT5_ADD_RESOURCES(libqmmpfiledialog_RCC_SRCS ${libqmmpfiledialog_RCCS})

# user interface


SET(libqmmpfiledialog_UIS
    qmmpfiledialog.ui
)

QT5_WRAP_UI(libqmmpfiledialog_UIS_H ${libqmmpfiledialog_UIS})
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(qmmpfiledialog MODULE ${libqmmpfiledialog_SRCS} ${libqmmpfiledialog_UIS_H} ${libqmmpfiledialog_RCC_SRCS})
add_dependencies(qmmpfiledialog qmmpui)
target_link_libraries(qmmpfiledialog Qt5::Widgets -lqmmpui -lqmmp)
install(TARGETS qmmpfiledialog DESTINATION ${LIB_DIR}/qmmp/FileDialogs)

=== src/plugins/General/covermanager/CMakeLists.txt ===
project(libcovermanager)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
#libqmmp
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libcovermanager_SRCS
    coverwidget.cpp
    covermanager.cpp
    covermanagerfactory.cpp
)

SET(libcovermanager_RCCS
    translations/translations.qrc
    images/cm_images.qrc
)

QT5_ADD_RESOURCES(libcovermanager_RCC_SRCS ${libcovermanager_RCCS})

# user interface


SET(libcovermanager_UIS
)

QT5_WRAP_UI(libcovermanager_UIS_H ${libcovermanager_UIS})
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(covermanager MODULE ${libcovermanager_SRCS} ${libcovermanager_UIS_H}
  ${libcovermanager_RCC_SRCS})
add_dependencies(covermanager qmmpui)
target_link_libraries(covermanager Qt5::Widgets -lqmmpui -lqmmp)
install(TARGETS covermanager DESTINATION ${LIB_DIR}/qmmp/General)

=== src/plugins/General/gnomehotkey/CMakeLists.txt ===
project(libgnomehotkey)

if(COMMAND cmake_policy)
cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui & libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libgnomehotkey_SRCS
    gnomehotkeyfactory.cpp
    mediakeys.cpp
)

SET(libgnomehotkey_RCCS translations/translations.qrc)

QT5_ADD_RESOURCES(libgnomehotkey_RCC_SRCS ${libgnomehotkey_RCCS})

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(gnomehotkey MODULE ${libgnomehotkey_SRCS} ${libgnomehotkey_RCC_SRCS})
add_dependencies(gnomehotkey qmmpui)
target_link_libraries(gnomehotkey Qt5::Widgets Qt5::DBus -lqmmpui -lqmmp)
install(TARGETS gnomehotkey DESTINATION ${LIB_DIR}/qmmp/General)

=== debian/changelog ===
qmmp (1.1.10-1.1ubuntu2) bionic; urgency=medium

  * No-change rebuild against libcdio17

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 06 Dec 2017 02:52:46 +0000

qmmp (1.1.10-1.1ubuntu1) bionic; urgency=medium

  * Merge with Debian; remaining changes:

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 18:44:45 +0100

qmmp (1.1.10-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on qttools5-dev. Closes: #881084.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Nov 2017 18:35:41 +0100

qmmp (1.1.10-1ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Disable qmmp-plugin-projectm on arm64, where Qt is also linked to
      GLESv2 in Ubuntu.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Oct 2017 16:05:53 -0700

qmmp (1.1.10-1) unstable; urgency=medium

  * Acknowledging NMU.
  * New upstream release. Closes: #855826, #857962.
  * Bump Standards-Version to 4.1.0 (no changes needed).
  * projectm: add missing Depends on ttf-dejavu-core.

 -- Matteo Cypriani <mcy@lm7.fr>  Thu, 24 Aug 2017 20:39:12 -0400

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Matteo Cypriani <mcy@lm7.fr>
 Build-Depends: debhelper (>= 10), cmake, pkg-config, qtbase5-dev (>= 5.4),
-  libqt5x11extras5-dev (>= 5.4), qttools5-dev-tools (>= 5.4),
+  libqt5x11extras5-dev (>= 5.4), qttools5-dev-tools (>= 5.4), qttools5-dev,
   qtchooser, libx11-dev, oss4-dev [!linux-any], libmad0-dev, libvorbis-dev,
   libogg-dev, libasound2-dev [linux-any], libtag1-dev (>= 1.10),
   libcurl4-gnutls-dev, qtmultimedia5-dev (>= 5.4), libmms-dev,
@@ -14,7 +14,7 @@
   libcddb2-dev, libfaad-dev, libgme-dev, libopus-dev (>= 1.0.2),
   libopusfile-dev, libwildmidi-dev, libsidplayfp-dev (>= 1.0.3),
   libbs2b-dev, libprojectm-dev [!armel !armhf !arm64], libenca-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Homepage: http://qmmp.ylsoftware.com/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/qmmp.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/qmmp.git
@@ -89,7 +89,7 @@
 
 Package: qmmp-plugin-projectm
 Architecture: any-amd64 any-i386 any-mips any-mipsel any-powerpc any-ppc64el any-s390x any-alpha any-hppa any-m68k any-mips64el any-powerpcspe any-sh4 any-sparc64 any-x32
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core
 Description: qmmp audio player -- projectM visualization plugin
  Qmmp is feature-rich audio player with support of many formats.
  It is written in Qt.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

ifeq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_CMAKE_ARGS = -DUSE_HAL:BOOL=FALSE -DUSE_OSS4:BOOL=FALSE
else
	EXTRA_CMAKE_ARGS = -DUSE_ALSA:BOOL=FALSE -DUSE_UDISKS:BOOL=FALSE
endif

# For hardening (CPPFLAGS is not taken into account by upstream's build system)
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

# Prevent useless dependencies
LDFLAGS += -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DLIB_DIR=lib/qmmp \
	  -DCMAKE_INSTALL_RPATH=/usr/lib/qmmp \
	  -DCMAKE_BUILD_WITH_INSTALL_RPATH:BOOL=TRUE \
	  $(EXTRA_CMAKE_ARGS)

override_dh_auto_build:
	dh_auto_build -- VERBOSE=1

override_dh_install:
ifneq (,$(filter-out armel armhf arm64,$(DEB_HOST_ARCH)))
	dh_install -pqmmp-plugin-projectm
endif
	dh_install -Xprojectm

# Avoid a call to ldconfig in postinst & postrm (ldconfig is not needed since we
# only install private libraries)
override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# dh_auto_clean doesn't call make distclean automatically from the CMake build
# directory, so we have to remove leftover .qm files manually
override_dh_auto_clean:
	find -name '*.qm' | xargs rm -fv
	dh_auto_clean

## qmmp 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,10 @@
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
   SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
 ENDIF()
+
+if(POLICY CMP0071)
+  cmake_policy(SET CMP0071 NEW)
+endif()
 
 #Qt5 modules
 SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /opt/qt56/lib/cmake)
@@ -155,6 +159,7 @@
 PRINT_SUMMARY ("Game music support ................" USE_GME GME_FOUND)
 PRINT_SUMMARY ("Ogg Opus support .................." USE_OPUS OPUS_FOUND)
 PRINT_SUMMARY ("SID support ......................." USE_SID SIDPLAYFP_FOUND)
+PRINT_SUMMARY ("Archive support ..................." USE_ARCHIVE LIBARCHIVE_FOUND)
 
 MESSAGE("")
 MESSAGE("Output Plugins:")
@@ -168,6 +173,7 @@
 PRINT_SUMMARY ("Win32 DirectSound support ........." USE_DSOUND DSOUND_H_FOUND)
 PRINT_SUMMARY ("Win32 WASAPI support .............." USE_WASAPI WASAPI_FOUND)
 PRINT_SUMMARY ("Qt Multimedia support ............." USE_QTMULTIMEDIA Qt5Multimedia_FOUND)
+PRINT_SUMMARY ("Icecast support ..................." USE_SHOUT SHOUT_FOUND)
 
 MESSAGE("")
 MESSAGE("Effect Plugins:")
@@ -176,6 +182,7 @@
 PRINT_SUMMARY ("LADSPA Host ......................." USE_LADSPA 1)
 PRINT_SUMMARY ("Crossfade ........................." USE_CROSSFADE 1)
 PRINT_SUMMARY ("Extra Stereo ......................" USE_STEREO 1)
+PRINT_SUMMARY ("File Writer ......................." USE_FILEWRITER VORBISENC_FOUND)
 
 MESSAGE("")
 MESSAGE("Visual Plugins:")

=== debian/changelog ===
qmmp (1.2.2-1ubuntu1) cosmic; urgency=medium

  * Merge with Debian; remaining changes:
    - Disable qmmp-plugin-projectm on arm64, where Qt is also linked to
      GLESv2 in Ubuntu.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Jul 2018 12:55:40 +0200

qmmp (1.2.2-1) unstable; urgency=medium

  * Acknowledging NMU.
  * New upstream version. Closes: #888362.
  * Update debian/copyright
  * Bump Standards-Version to 4.1.4 (no changes needed).

 -- Matteo Cypriani <mcy@lm7.fr>  Wed, 13 Jun 2018 22:04:33 +0200

qmmp (1.2.0-1ubuntu2) cosmic; urgency=medium

  * No-change rebuild for libcdio soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Jun 2018 00:35:30 +0000

qmmp (1.2.0-1ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Disable qmmp-plugin-projectm on arm64, where Qt is also linked to
      GLESv2 in Ubuntu.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 15 May 2018 11:51:42 -0700

qmmp (1.2.0-1) unstable; urgency=medium

  * New upstream version 1.2.0.
    + Add libarchive and libshout as build-depends to enable new features.
    + Update package description.
  * Add patch: Quit including moc_hotkeymanager.cpp. Closes: #891215.
  * Don'd depend on transitional dummy package ttf-dejavu-core, use
    fonts-dejavu-core instead. Closes: #885568.
  * Add missing build-depend qttools5-dev.
  * Bump Standards-Version to 4.1.3 (no changes needed).
  * Switch to debhelper compat 11 (no changes needed).
  * Update Vcs URLs to salsa.d.o.
  * Update copyright and upstream/metadata.

 -- Matteo Cypriani <mcy@lm7.fr>  Thu, 08 Mar 2018 21:49:21 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Matteo Cypriani <mcy@lm7.fr>
-Build-Depends: debhelper (>= 10), cmake, pkg-config, qtbase5-dev (>= 5.4),
-  libqt5x11extras5-dev (>= 5.4), qttools5-dev-tools (>= 5.4), qttools5-dev,
+Build-Depends: debhelper (>= 11), cmake, pkg-config, qtbase5-dev (>= 5.4),
+  libqt5x11extras5-dev (>= 5.4), qttools5-dev (>= 5.4),
+  qttools5-dev-tools (>= 5.4),
   qtchooser, libx11-dev, oss4-dev [!linux-any], libmad0-dev, libvorbis-dev,
   libogg-dev, libasound2-dev [linux-any], libtag1-dev (>= 1.10),
   libcurl4-gnutls-dev, qtmultimedia5-dev (>= 5.4), libmms-dev,
@@ -13,11 +14,12 @@
   libavcodec-dev, libavformat-dev, libcdio-dev, libcdio-paranoia-dev,
   libcddb2-dev, libfaad-dev, libgme-dev, libopus-dev (>= 1.0.2),
   libopusfile-dev, libwildmidi-dev, libsidplayfp-dev (>= 1.0.3),
-  libbs2b-dev, libprojectm-dev [!armel !armhf !arm64], libenca-dev
-Standards-Version: 4.1.0
+  libbs2b-dev, libprojectm-dev [!armel !armhf !arm64], libenca-dev,
+  libarchive-dev (>= 3.2), libshout3-dev
+Standards-Version: 4.1.4
 Homepage: http://qmmp.ylsoftware.com/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/qmmp.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/qmmp.git
+Vcs-Git: https://salsa.debian.org/debian/qmmp.git
+Vcs-Browser: https://salsa.debian.org/debian/qmmp
 
 Package: qmmp
 Architecture: any
@@ -60,6 +62,7 @@
   - PulseAudio
   - JACK
   - QTMultimedia
+  - Icecast
  .
  Other features:
   - XMMS and Winamp 2.x skins support
@@ -84,12 +87,14 @@
   - audio formats converter
   - external programs execution on track change
   - ReplayGain scanner
+  - archive reader
+  - audio recording
   - visualization (spectre analyzer, projectm)
   - global hotkeys
 
 Package: qmmp-plugin-projectm
 Architecture: any-amd64 any-i386 any-mips any-mipsel any-powerpc any-ppc64el any-s390x any-alpha any-hppa any-m68k any-mips64el any-powerpcspe any-sh4 any-sparc64 any-x32
-Depends: ${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core
+Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
 Description: qmmp audio player -- projectM visualization plugin
  Qmmp is feature-rich audio player with support of many formats.
  It is written in Qt.
